<?php
namespace mysterious\productlayout\classes;
class vcmap {
    private static $_instance = null;
    public function __construct()
    {
        $this->_map();
    }
    public static function instance()
    {
        if (is_null(self::$_instance)) {
            self::$_instance = new self();
        }
        return self::$_instance;
    }
    public function _map(){
		// Shop
        vc_map ( array (
			'name' 			=> esc_html__( "Categories", MST_CPLFVC ),
			'base' 			=> "mst_cplfvc_list_categories",
			'category' 		=> esc_html__( 'Content','js_composer'),
			'icon' 			=> "icon-mst_cplfvc-product-shop",
			'params' 		=> array (
					array(
						'type' 			=> 'textfield',
						'heading' 		=> esc_html__( 'Number', 'js_composer' ),
						'param_name' 	=> 'number',
						'save_always'	=> true,
						'value'			=> '',
						'description' 	=> esc_html__( 'The `number` field is used to display the number of products.', 'js_composer' ),
					),
					array(
							'type' 			=> 'dropdown',
							'heading' 		=> esc_html__( 'Columns', 'js_composer' ),
							'param_name' 	=> 'columns',
							'save_always'	=> true,
							'description' 	=> esc_html__( 'How much columns grid', 'js_composer' ),
							'value' 		=> array (
									'1' => 1,
									'2' => 2,
									'3' => 3,		
									'4' => 4,
									'5' => 5
							),
							'std' 			=> 3			
					),
					array(
						'type' 			=> 'dropdown',
						'heading' 		=> esc_html__( 'Order by', 'js_composer' ),
						'param_name' 	=> 'orderby',	
						'save_always'	=> true,
						'value' 		=> array (
							esc_html__( 'Date', 'js_composer' ) => 'date',
							esc_html__( 'ID', 'js_composer' ) => 'ID',
							esc_html__( 'Author', 'js_composer' ) => 'author',
							esc_html__( 'Title', 'js_composer' ) => 'title',
							esc_html__( 'Modified', 'js_composer' ) => 'modified',
							esc_html__( 'Random', 'js_composer' ) => 'rand',
							esc_html__( 'Comment count', 'js_composer' ) => 'comment_count',
							esc_html__( 'Menu order', 'js_composer' ) => 'menu_order',
							esc_html__( 'Menu order & title', 'js_composer' ) => 'menu_order title',
							esc_html__( 'Include', 'js_composer' ) => 'include',
						),		
					),
					array (
						'type' 			=> 'dropdown',
						'class' 		=> '',
						'save_always'	=> true,
						'heading' 		=> esc_html__( 'Sort order', 'js_composer' ),
						'param_name' 	=> 'order',
						'value' 		=> array (
							esc_html__( 'Descending', 'js_composer' ) => 'DESC',
							esc_html__( 'Ascending', 'js_composer' ) => 'ASC',
						),
						'std' 			=> 'ASC',
						'description' 	=> sprintf( esc_html__( 'Designates the ascending or descending order. More at %s.', 'js_composer' ), '<a href="https://codex.wordpress.org/Class_Reference/WP_Query#Order_.26_Orderby_Parameters" target="_blank">WordPress codex page</a>' ),
					)
			)
		) );
		vc_map ( array (
			'name' 			=> esc_html__( 'Products', MST_CPLFVC ),
			'base' 			=> 'mst_cplfvc_list_product',
			'category' 		=> esc_html__( 'Content','js_composer'),
			'icon' 			=> 'icon-mst_cplfvc-product-shop',
			'params' 		=> array (
					array (
						'type' 			=> 'textfield',
						'heading' 		=> esc_html__( 'Extra class name', 'js_composer' ),
						'param_name' 	=> 'el_class',
						'save_always'	=> true,
						'value'			=>'',
						'description' => esc_html__( 'If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.', 'js_composer' )
					)
			)
		) );	
	
		// Product Category
		vc_map ( array (
			'name' 			=> esc_html__( 'Product category name', MST_CPLFVC ),
			'base' 			=> 'mst_cplfvc_product_name_category',
			'category' 		=> esc_html__( 'Content','js_composer'),
			'icon' 			=> 'icon-mst_cplfvc-product-category',
			'params' 		=> $this->archive_name_params()
		) );
		vc_map ( array (
			'name' 			=> esc_html__( 'Product category description', MST_CPLFVC ),
			'base' 			=> 'mst_cplfvc_product_description_category',
			'category' 		=> esc_html__( 'Content','js_composer'),
			'icon' 			=> 'icon-mst_cplfvc-product-category',
			'params' 		=> $this->archive_desc_params()
		) );
		vc_map ( array (
			'name' 			=> esc_html__( "Products by Category", MST_CPLFVC ),
			'base' 			=> "mst_cplfvc_product_category",
			'category' 		=> esc_html__( 'Content','js_composer'),
			'icon' 			=> 'icon-mst_cplfvc-product-category',
			'params' 		=> $this->archive_product_params() 
		) );
		vc_map ( array (
			'name' 					=> esc_html__('Products by Category with filter',MST_CPLFVC ),
			'base' 					=> 'mst_cplfvc_product_category_filter',
			'category' 				=> esc_html__( 'Content','js_composer'),
			'icon' 					=> 'icon-mst_cplfvc-product-category',
			'params' 				=> array (
				array (
					'type' 			=> 'textfield',
					'admin_label' 	=> true,
					'heading' 		=> esc_html__( 'Extra class name', 'js_composer' ),
					'param_name' 	=> 'el_class',
					'save_always'	=> true,
					'value'			=> '',
					'description' 	=> esc_html__( 'If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.', 'js_composer' )
				)
			)
		) );
		
		// Product
		vc_map ( array (
			'name' 		=> esc_html__( 'Images', MST_CPLFVC ),
			'base' 		=> "mst_cplfvc_product_images",
			'category' 	=> esc_html__( 'Content','js_composer'),
			'icon' 		=> 'icon-mst_cplfvc-product-single',
			'params' 	=> $this->get_product_detail_params()
		) );
		vc_map ( array (
			'name' 		=> esc_html__( 'Title', MST_CPLFVC ),
			'base' 		=> 'mst_cplfvc_product_title',
			'category' 	=> esc_html__( 'Content','js_composer'),
			'icon' 		=> 'icon-mst_cplfvc-product-single',
			'params' 	=> $this->get_product_detail_params()
		) );
		vc_map ( array (
			'name' 		=> esc_html__( 'Rating', MST_CPLFVC ),
			'base' 		=> 'mst_cplfvc_product_rating',
			'category' 	=> esc_html__( 'Content','js_composer'),
			'icon' 		=> 'icon-mst_cplfvc-product-single',
			'params' 	=> $this->get_product_detail_params()
		) );
		vc_map ( array (
			'name' 		=> esc_html__( 'Price', MST_CPLFVC ),
			'base' 		=> 'mst_cplfvc_product_price',
			'category' 	=> esc_html__( 'Content','js_composer'),
			'icon' 		=> 'icon-mst_cplfvc-product-single',
			'params' 	=> $this->get_product_detail_params()
		) );
		vc_map ( array (
			'name' 		=> esc_html__( 'Share', MST_CPLFVC ),
			'base' 		=> 'mst_cplfvc_product_share',
			'category' 	=> esc_html__( 'Content','js_composer'),
			'icon' 		=> 'icon-mst_cplfvc-product-single',
			'params' 	=> $this->get_product_detail_params()
		) );
		vc_map ( array (
			'name' 		=> esc_html__( 'Excerpt', MST_CPLFVC ),
			'base' 		=> 'mst_cplfvc_product_excert',
			'category' 	=> esc_html__( 'Content','js_composer'),
			'icon' 		=> 'icon-mst_cplfvc-product-single',
			'params' 	=> $this->get_product_detail_params()
		) );
		vc_map ( array (
			'name' 		=> esc_html__( 'Add To Cart', MST_CPLFVC ),
			'base' 		=> 'mst_cplfvc_product_add_to_cart',
			'category' 	=> esc_html__( 'Content','js_composer'),
			'icon' 		=> 'icon-mst_cplfvc-product-single',
			'params' 	=> $this->get_product_detail_params()
		) );
		vc_map ( array (
			'name' 		=> esc_html__( 'Meta', MST_CPLFVC ),
			'base' 		=> 'mst_cplfvc_product_cat_product_single',
			'category' 	=> esc_html__( 'Content','js_composer'),
			'icon' 		=> 'icon-mst_cplfvc-product-single',
			'params' 	=> $this->get_product_detail_params()
		) );
		vc_map ( array (
			'name' 		=> esc_html__( 'Description', MST_CPLFVC ),
			'base' 		=> "mst_cplfvc_product_description",
			'category' 	=> esc_html__( 'Content','js_composer'),
			'icon' 		=> 'icon-mst_cplfvc-product-single',
			'params' 	=> $this->get_product_detail_params()
		) );
		vc_map ( array (
			'name' 		=> esc_html__( 'Reviews', MST_CPLFVC ),
			'base' 		=> 'mst_cplfvc_product_review',
			'category' 	=> esc_html__( 'Content','js_composer'),
			'icon' 		=> 'icon-mst_cplfvc-product-single',
			'params' 	=> $this->get_product_detail_params()
		) );
		vc_map ( array (
			'name' 		=> esc_html__( 'Additional Information', MST_CPLFVC ),
			'base' 		=> 'mst_cplfvc_product_additional_information',
			'category' 	=> esc_html__( 'Content','js_composer'),
			'icon' 		=> 'icon-mst_cplfvc-product-single',
			'params' 	=> $this->get_product_detail_params()
		) );
		vc_map ( array (
			'name' 				=> esc_html__( 'Data Tab', MST_CPLFVC ),
			'base' 				=> 'mst_cplfvc_product_show_tab',
			'category' 	=> esc_html__( 'Content','js_composer'),
			'icon' 		=> 'icon-mst_cplfvc-product-single',
			'params' 	=> $this->get_product_detail_params()
		) );
		vc_map ( array (
			'name' 					=> esc_html__( 'Product Related', MST_CPLFVC ),
			'base' 					=> 'mst_cplfvc_product_relate',
			'category' 				=> esc_html__( 'Content','js_composer'),
			'icon' 					=> 'icon-mst_cplfvc-product-single',
			'params' 				=> array (
				array (
					'type' 			=> 'textfield',
					'save_always'	=> true,
					'heading' 		=> esc_html__( 'Per page', 'js_composer' ),
					'param_name' 	=> "posts_per_page",
					'value' 		=> 3,
					'description' 	=> esc_html__( 'How much items per page to show', 'js_composer' ),
				),
				array (
					'type' 			=> 'dropdown',
					'heading' 		=> esc_html__( 'columns', 'js_composer' ),
					'param_name' 	=> 'columns',
					'save_always'	=> true,
					'value' 		=> array (
						'1' => 1,
						'2' => 2,
						'3' => 3,		
						'4' => 4,
						'5' => 5,
						'6' => 6
					),
					'std' 			=> 3,
				),
				array (
					'type' 			=> 'dropdown',
					'heading' 		=> esc_html__( 'Order by', 'js_composer' ),
					'param_name' 	=> 'orderby',
					'save_always'	=> true,
					'value' => array (
						esc_html__( 'Random', MST_CPLFVC ) 				=> 'rand',
						esc_html__( 'Publish Date', MST_CPLFVC ) 		=> 'date',
						esc_html__( 'Modified Date', MST_CPLFVC ) 		=> 'modified',		
						esc_html__( 'Alphabetic', MST_CPLFVC ) 			=> 'title',
						esc_html__( 'Popularity', MST_CPLFVC ) 			=> 'popularity',
						esc_html__( 'Rate', MST_CPLFVC ) 				=> 'rating',
						esc_html__( 'Price', MST_CPLFVC ) 				=> 'price'
					)
				),
				array (
					'type' 			=> 'textfield',
					'heading' 		=> esc_html__( 'Extra class name', 'js_composer' ),
					'param_name' 	=> 'el_class',
					'save_always'	=> true,
					'value'			=> '',
					'description' 	=> esc_html__( 'If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.', 'js_composer' )
				)
			)
		) );
		vc_map ( array (
			'name' 				=> esc_html__( 'Product Upsell', MST_CPLFVC ),
			'base' 				=> 'mst_cplfvc_product_upsell',
			'category' 			=> esc_html__( 'Content','js_composer'),
			'icon' 				=> 'icon-mst_cplfvc-product-single',
			'params' 			=> array (
				array (
					'type' 			=> 'textfield',
					'save_always'	=> true,
					'heading' 		=> esc_html__( 'Per page', 'js_composer' ),
					'param_name' 	=> "posts_per_page",
					'value' 		=> 4,
					'description' 	=> esc_html__( 'How much items per page to show', 'js_composer' ),
				),
				array (
					'type' 			=> 'dropdown',
					'heading' 		=> esc_html__( 'columns', 'js_composer' ),
					'param_name' 	=> 'columns',
					'save_always'	=> true,
					'value' 		=> array (
						'1' => 1,
						'2' => 2,
						'3' => 3,		
						'4' => 4,
						'5' => 5,
						'6' => 6
					),
					'std' 			=> 3,
				),
				array (
					'type' 			=> 'dropdown',
					'heading' 		=> esc_html__( 'Order by', 'js_composer' ),
					'param_name' 	=> 'orderby',
					'save_always'	=> true,
					'class' 		=> '',
					'value' 		=> array (
						esc_html__( 'Random', MST_CPLFVC ) 			=> 'rand',
						esc_html__( 'Publish Date', MST_CPLFVC ) 	=> 'date',
						esc_html__( 'Modified Date', MST_CPLFVC ) 	=> 'modified',			
						esc_html__( 'Alphabetic', MST_CPLFVC ) 		=> 'title',
						esc_html__( 'Popularity', MST_CPLFVC ) 		=> 'popularity',
						esc_html__( 'Rate', MST_CPLFVC ) 			=> 'rating',
						esc_html__( 'Price', MST_CPLFVC ) 			=> 'price'
					)
				),               
				array (
					'type' 			=> 'textfield',
					'heading' 		=> esc_html__( 'Extra class name', 'js_composer' ),
					'param_name' 	=> 'el_class',
					'save_always'	=> true,
					'value'			=> '',
					'description' 	=> esc_html__( 'If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.', 'js_composer' )
				)
			)
		) );
		//IS THEME ELECTRO
		if(get_option('template')==='electro'){
			vc_map ( array (
				'name' 			=> esc_html__( 'Product Availability', MST_CPLFVC ),
				'base' 			=> 'mst_cplfvc_product_availability',
				'category' 		=> esc_html__( 'Content','js_composer'),
				'icon' 			=> 'icon-mst_cplfvc-product-single',
				'params' 		=> $this->get_product_detail_params()
			) );

			vc_map ( array (
				'name' 			=> esc_html__( 'Product Categories', MST_CPLFVC ),
				'base' 			=> 'mst_cplfvc_product_categories',
				'category' 		=> esc_html__( 'Content','js_composer'),
				'icon' 			=> 'icon-mst_cplfvc-product-single',
				'params' 		=> $this->get_product_detail_params()
			) );

			vc_map ( array (
				'name' 			=> esc_html__( 'Add To Wishlist', MST_CPLFVC ),
				'base' 			=> "mst_cplfvc_product_add_to_wishlist",
				'category' 		=> esc_html__( 'Content','js_composer'),
				'icon' 			=> 'icon-mst_cplfvc-product-single',
				'params' 		=> $this->get_product_detail_params()
			) );
		}
		// PRODUCT TAG
		vc_map ( array (
			'name' 			=> esc_html__( 'Product brand name', MST_CPLFVC ),
			'base' 			=> 'mst_cplfvc_product_name_tag',
			'category' 		=> esc_html__( 'Content','js_composer'),
			'icon' 			=> 'icon-mst_cplfvc-product-tag',
			'params' 		=> $this->archive_name_params()
		) );
		vc_map ( array (
			'name' 			=> esc_html__( 'Product tag description', MST_CPLFVC ),
			'base' 			=> 'mst_cplfvc_product_description_tag',
			'category' 		=> esc_html__( 'Content','js_composer'),
			'icon' 			=> 'icon-mst_cplfvc-product-tag',
			'params' 		=> $this->archive_desc_params()
		) );
        vc_map ( array (
			'name' 			=> esc_html__( 'Products by Tag', MST_CPLFVC ),
			'base' 			=> 'mst_cplfvc_product_tags',
			'category' 		=> esc_html__( 'Content','js_composer'),
			'icon' 			=> 'icon-mst_cplfvc-product-tag',
			'params' 		=> $this->archive_product_params()
		) );

		// PRODUCT BRAND
		vc_map ( array (
			'name' 			=> esc_html__( 'Product brand name', MST_CPLFVC ),
			'base' 			=> 'mst_cplfvc_product_name_brand',
			'category' 		=> esc_html__( 'Content','js_composer'),
			'icon' 			=> 'icon-mst_cplfvc-product-brand',
			'params' 		=> $this->archive_name_params() 
		) );
		vc_map ( array (
			'name' 			=> esc_html__( 'Product brand description', MST_CPLFVC ),
			'base' 			=> 'mst_cplfvc_product_description_brand',
			'category' 		=> esc_html__( 'Content','js_composer'),
			'icon' 			=> 'icon-mst_cplfvc-product-brand',
			'params' 		=> $this->archive_desc_params()
		) );
        vc_map ( array (
			'name' 			=> esc_html__( 'Products by Brand', MST_CPLFVC ),
			'base' 			=> 'mst_cplfvc_product_brand',
			'category' 		=> esc_html__( 'Content','js_composer'),
			'icon' 			=> 'icon-mst_cplfvc-product-brand',
			'params' 		=> $this->archive_product_params()
		) );

		// PRODUCT ATTRIBUTE
		vc_map ( array (
			'name' 			=> esc_html__( 'Product attribute name', MST_CPLFVC ),
			'base' 			=> 'mst_cplfvc_product_name_attribute',
			'category' 		=> esc_html__( 'Content','js_composer'),
			'icon' 			=> 'icon-mst_cplfvc-product-attribute',
			'params' 		=> $this->archive_name_params() 
		) );
		vc_map ( array (
			'name' 			=> esc_html__( 'Product attribute description', MST_CPLFVC ),
			'base' 			=> 'mst_cplfvc_product_description_attribute',
			'category' 		=> esc_html__( 'Content','js_composer'),
			'icon' 			=> 'icon-mst_cplfvc-product-attribute',
			'params' 		=> $this->archive_desc_params()
		) );
        vc_map ( array (
			'name' 			=> esc_html__( 'Products by Attribute', MST_CPLFVC ),
			'base' 			=> 'mst_cplfvc_product_attribute',
			'category' 		=> esc_html__( 'Content','js_composer'),
			'icon' 			=> 'icon-mst_cplfvc-product-attribute',
			'params' 		=> $this->archive_product_params()
		) );
    }
    
	public function archive_name_params()
	{
		$params = array (
			array (
				'type' 			=> 'dropdown',
				'heading' 		=> esc_html__( 'Tag', 'js_composer' ),
				'description' 	=> esc_html__( 'Select the HTML tag to display for the product category name.', MST_CPLFVC ),
				'param_name' 	=> "tag",
				'save_always'	=> true,
				'value' => array (
					'h1' 		=> 'h1',
					'h2' 		=> 'h2',
					'h3' 		=> 'h3',		
					'h4' 		=> 'h4',
					'h5' 		=> 'h5',
					'h6' 		=> 'h6',
					'p' 		=> 'p',
				),
				'std' => 'h2', 
			),
			array (
				'type' 			=> 'dropdown',
				'heading' 		=> esc_html__( 'Text alignment', 'js_composer' ),
				'param_name' 	=> 'text_align',
				'save_always'	=> true,
				'value' 		=> array(
					'Left' => 'left',
					'Right' => 'right',
					'Center' => 'center',
					'Justify' => 'justify',
				),
				'std' 			=> 'center',
			),
			array(
				'type' 			=> 'textfield',
				'heading' 		=> esc_html__( 'Font size', 'js_composer'),
				'description' 	=> esc_html__( 'Enter font size, example: 16px, 16rem, 1.6em ... Default: xxx-large.', MST_CPLFVC ),
				'param_name' 	=> 'font_size',
			),
			array(
				'type' 			=> 'textfield',
				'heading' 		=> esc_html__( 'Line height', 'js_composer' ),
				'param_name' 	=> 'line_height',
				'description' 	=> esc_html__( 'Enter line height.', 'js_composer' ),
			),
			array(
				'type' 			=> 'colorpicker',
				'heading' 		=> esc_html__( 'Text color', 'js_composer' ),
				'param_name' 	=> 'color',
				'description' 	=> esc_html__( 'Select custom text color.', 'js_composer' ),
			),
			array(
				'type' 			=> 'checkbox',
				'heading' 		=> esc_html__( 'Use theme default font family?', 'js_composer' ),
				'param_name' 	=> 'use_fonts',
				'value'       	=> array( esc_html__( 'No', 'js_composer' ) => 'no' ),
				'description' 	=> esc_html__( 'Use font family from the theme.', 'js_composer' ),
			),
			array(
				'type' 			=> 'google_fonts',
				'param_name' 	=> 'google_fonts',
				'value' 		=> 'font_family:Abril%20Fatface%3Aregular|font_style:400%20regular%3A400%3Anormal',
				'settings' 		=> array(
					'fields' => array(
						'font_family_description' 	=> esc_html__( 'Select font family.', 'js_composer' ),
						'font_style_description' 	=> esc_html__( 'Select font styling.', 'js_composer' ),
					),
				),
				'dependency' => array(
					'element' => 'use_fonts',
					'value' => 'no',
				),
			),
			array (
				'type' 			=> 'textfield',
				'heading' 		=> esc_html__( 'Extra class name', 'js_composer' ),
				'param_name' 	=> 'el_class',
				'save_always'	=> true,
				'value'			=> '',
				'description' 	=> esc_html__( 'If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.', 'js_composer' )
			)
		);
		return $params;
	}

	public function archive_desc_params()
	{
		$params =  array (		
			array(
				'type' 			=> 'textfield',
				'heading' 		=> esc_html__( 'Font size', 'js_composer'),
				'description' 	=> esc_html__( 'Enter font size, example: 16px, 16rem, 1.6em ... Default: inherit.', MST_CPLFVC ),
				'param_name' 	=> 'size',
				'value'			=> '',
			),
			array (
				'type' 			=> 'dropdown',
				'heading' 		=> esc_html__( 'Text alignment', 'js_composer' ),
				'param_name' 	=> 'text_align',
				'save_always'	=> true,
				'value' 		=> array(
					'Left' => 'left',
					'Right' => 'right',
					'Center' => 'center',
					'Justify' => 'justify',
				),
			),
			array(
				'type' 			=> 'colorpicker',
				'heading' 		=> esc_html__( 'Text color', 'js_composer' ),
				'param_name' 	=> 'color',
				'value'			=> '',
				'description' 	=> esc_html__( 'Select custom text color.', 'js_composer' ),
			),
			array(
				'type' 			=> 'checkbox',
				'heading' 		=> esc_html__( 'Use theme default font family?', 'js_composer' ),
				'param_name' 	=> 'use_fonts',
				'value'       	=> array( esc_html__( 'No', 'js_composer' ) => 'no' ),
				'description' 	=> esc_html__( 'Use font family from the theme.', 'js_composer' ),
			),
			array(
				'type' 			=> 'google_fonts',
				'param_name' 	=> 'google_fonts',
				'value' 		=> 'font_family:Abril%20Fatface%3Aregular|font_style:400%20regular%3A400%3Anormal',
				'settings' 		=> array(
					'fields' => array(
						'font_family_description' 	=> esc_html__( 'Select font family.', 'js_composer' ),
						'font_style_description' 	=> esc_html__( 'Select font styling.', 'js_composer' ),
					),
				),
				'dependency' 	=> array(
						'element' => 'use_fonts',
						'value' => 'no',
				)
			),
			array(
					'type' 			=> 'textfield',
					'heading' 		=> esc_html__( 'Extra class name', 'js_composer' ),
					'param_name' 	=> 'el_class',
					'save_always'	=> true,
					'value'			=> '',
					'description' 	=> esc_html__( 'If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.', 'js_composer' )
			),	
		);
		return $params;
	}

	public function archive_product_params()
	{
		$params = array (
			array (
				'type' 			=> 'mst_layout_label',
				'heading' 		=> esc_html__( 'Products per Page', 'js_composer' ),
				'param_name' 	=> 'per_page',
				'save_always'	=> true,
				'description' 	=> esc_html__( 'Number of products to show per page. (Default by theme)', 'js_composer' )
			),
			array (
				'type' 			=> 'dropdown',
				'admin_label' 		=> true,
				'heading' 		=> esc_html__( 'Columns', 'js_composer' ),
				'param_name' 	=> 'columns',
				'save_always'	=> true,
				'description' 	=> esc_html__( 'How much columns grid', 'js_composer' ),
				'value' 		=> array (
					'1' => 1,
					'2' => 2,
					'3' => 3,		
					'4' => 4,
					'5' => 5,
					'6' => 6,
				),
				'std' 			=> 3,
			),
			array (
				'type' 				=> 'mst_layout_label',
				'heading' 			=> esc_html__( 'Order by', 'js_composer' ),
				'param_name' 		=> 'orderby',
				'save_always'		=> true,
				'description' 		=> esc_html__( 'Select how to sort retrieved products. (Default by theme)', 'js_composer' )
			),
			array (
				'type' 				=> 'mst_layout_label',
				'heading' 			=> esc_html__( 'Sort order', 'js_composer' ),
				'param_name' 		=> 'order',
				'save_always'		=> true,
				'description' 		=> esc_html__( 'Designates the ascending or descending order. (Default by theme)', 'js_composer' )
			),
			array (
				'type' 			=> 'textfield',
				'heading' 		=> esc_html__( 'Extra class name', 'js_composer' ),
				'param_name' 	=> 'el_class',
				'save_always'	=> true,
				'value'			=> '',
				'description' 	=> esc_html__( 'If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.', 'js_composer' )
			)
		);
		return $params;
	}

	public function get_product_detail_params()
	{
		$params = array (
			array (
				'type' 			=> 'textfield',
				'heading' 		=> esc_html__( 'Extra class name', 'js_composer' ),
				'param_name' 	=> 'el_class',
				'save_always'	=> true,
				'value'			=> '',
				'description' 	=> esc_html__( 'If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.', 'js_composer' )
			)
		);
		return $params;
	}
}