<?php
namespace mysterious\productlayout\controllers;
use function mysterious\productlayout\productLayoutWPB;
class fields
{
    private static $_instance = null;

    public function __construct()
    {
        global $pagenow;
        if (
            in_array($pagenow, array('edit-tags.php', 'term.php'))
            ||
            ('admin-ajax.php' == $pagenow && 'add-tag' == $_REQUEST['action'])
        ) {
            $taxonomy = isset($_REQUEST['taxonomy']) ? sanitize_text_field($_REQUEST['taxonomy']) : false;
            if ($taxonomy && 'pa_' == substr($taxonomy, 0, 3)) {
                add_action("{$taxonomy}_add_form_fields", array($this, "product_attribute_add_edit_form_fields"), 10);
                add_action("{$taxonomy}_edit_form_fields", array($this, "product_attribute_add_edit_form_fields"), 10, 2);
                add_action("created_{$taxonomy}", array($this, 'save_add_edit_product_attribute'), 10, 2);
                add_action("edited_{$taxonomy}", array($this, 'save_add_edit_product_attribute'), 10, 2);
            }else{
                $fields = array('product_cat','product_tag','product_brand');
                foreach($fields as $key => $archive){
                    add_action("{$archive}_edit_form_fields", array($this,"{$archive}_add_edit_form_fields") );
                    add_action("{$archive}_add_form_fields", array($this,"{$archive}_add_edit_form_fields") );
                    add_action("edited_{$archive}", array($this,"save_add_edit_{$archive}_fields"), 10, 2 ); 
                    add_action("create_{$archive}", array($this,"save_add_edit_{$archive}_fields"), 10, 2 );
                }
            }
        }
        // PRODUCT META BOX
        add_action('add_meta_boxes',array($this,'add_product_meta_boxes'));
        add_action( 'save_post',array($this,'save_product_detail_fields'),1,2 );
        // CUSTOM FIELD FOR ATTRIBUTES
        add_action( 'woocommerce_after_add_attribute_fields', array($this, 'add_edit_attribute_fields') );
        add_action( 'woocommerce_after_edit_attribute_fields', array($this, 'add_edit_attribute_fields') );
        add_action( 'woocommerce_attribute_added', array($this, 'save_attribute_fields') );
        add_action( 'woocommerce_attribute_updated', array($this, 'save_attribute_fields'), 10, 1 );
        add_action( 'woocommerce_attribute_deleted', array($this, 'delete_attribute_fields'), 10, 1 );
    }
    public static function instance()
    {
        if (is_null(self::$_instance)) {
            self::$_instance = new self();
        }
        return self::$_instance;
    }
    
    public function product_attribute_add_edit_form_fields($term)
    {
        $types = array(
            'attribute'  => 'mst_cplfvc_product_attribute'
        );
        $this->add_form_fields_html($types,$term);
    }

    public function save_add_edit_product_attribute($term_id)
    {
        $language = productLayoutWPB()->current_language();
        $name = !empty($language) ? 'mst_cplfvc_product_attribute_'.$language : 'mst_cplfvc_product_attribute';
        $this->saveOption($term_id, array($name) );
    }

    public function product_cat_add_edit_form_fields($term)
    {
        $types = array(
            'category'  => 'mst_cplfvc_product_category',
            'single'    => 'mst_pclfvc_product_cat_single'
        );
        $this->add_form_fields_html($types,$term);
    }

    public function save_add_edit_product_cat_fields($term_id)
    {
        $language = productLayoutWPB()->current_language();
        if(!empty($language)){
            $name_category  = 'mst_cplfvc_product_category_'.$language;
            $name_product   = 'mst_pclfvc_product_cat_single_'.$language;
        }else{
            $name_category  = 'mst_cplfvc_product_category';
            $name_product   = 'mst_pclfvc_product_cat_single';
        }
        $this->saveOption($term_id, array($name_category, $name_product));

    }

    public function product_tag_add_edit_form_fields($term)
    {
        $types = array(
            'tags'  => 'mst_cplfvc_product_tags',
        );
        $this->add_form_fields_html($types,$term);
    }

    public function save_add_edit_product_tag_fields($term_id)
    {
        $language = productLayoutWPB()->current_language();
        $name = !empty($language) ? 'mst_cplfvc_product_tags_'.$language : 'mst_cplfvc_product_tags';
        $this->saveOption($term_id, array($name) );
    }

    
    public function product_brand_add_edit_form_fields($term)
    {
        $types = array(
            'brand'  => 'mst_cplfvc_product_brand',
        );
        $this->add_form_fields_html($types,$term);
    }

    public function save_add_edit_product_brand_fields($term_id)
    {
        $language = productLayoutWPB()->current_language();
        $name = !empty($language) ? 'mst_cplfvc_product_brand_'.$language : 'mst_cplfvc_product_brand';
        $this->saveOption($term_id, array($name) );
    }

    public function add_form_fields_html($types,$term)
    {
        $language   = productLayoutWPB()->current_language();
        $options    = array();
        foreach($types as $key => $value){
            $table      = productLayoutWPB()->get_table_by_type_template($key);
            $templates  = productLayoutWPB()->get_list_template_by_language($table,$language);
            $flag       = productLayoutWPB()->check_have_template_active($templates);
            $name       = !empty($language) ? $value.'_'.$language : $value;
            $template   = isset($term->term_id) ? get_term_meta( $term->term_id, $name, true ) : ""; 
            if($key === 'attribute'){
                if( empty($template) ){
                    if($flag){
                        $template = 'active';
                    }else{
                        $template = '';
                    }
                }
            }
            $data       = productLayoutWPB()->get_attr_archive_info($key);
            $txt_template = $key==='single' ?  esc_html__('Product Template',MST_CPLFVC) : esc_html__('Template',MST_CPLFVC);
            $options[] = array(
                'name'                  => $name,
                'txt_template'          => !empty($language) ? esc_html($txt_template)." (".$language.")" : esc_html($txt_template),
                'txt_depend_template'   => $data['txt_depend_template'],
                'value'                 => $template,
                'templates'             => $templates,
                'flag'                  => $flag,
                'desc'                  => $data['desc'],
                'desc_url'              => $data['desc_url'],
                'txt_all'               => $data['txt_all'],
            );
        }
        if($key === 'attribute'){
            productLayoutWPB()->get_file_template( 'metabox-special', array('options' => $options, 'type' => 'attribute') );
        }else{
            productLayoutWPB()->get_file_template( 'metabox', array('options' => $options) );
        }
        
    }

    public function saveOption($term_id, $data = array() )
    {
        foreach($data as $key => $value){
            if( isset($_POST[$value]) ){
                $template = sanitize_text_field( $_POST[$value] );
                update_term_meta($term_id, $value, $template);
            }
        }
    }
    // PRODUCT PAGE

    public function add_product_meta_boxes()
    {
        add_meta_box(
            'mst_cplfvc-products-meta-box', 
            esc_html__('Template',MST_CPLFVC),
            array($this,'product_single_add_edit_form_fields'),
            'product',
            'side'
        );
    }

    public function product_single_add_edit_form_fields($post)
    {
        $options        = array();
        $language       = productLayoutWPB()->current_language();
        $name           = !empty($language) ? 'mst_pclfvc_product_single_'.$language : 'mst_pclfvc_product_single';
        $table          = productLayoutWPB()->get_table_by_type_template('single');
        $data           = productLayoutWPB()->get_attr_archive_info('single');
        $txt_template   = esc_html__('Template',MST_CPLFVC);
        $options[] = array(
            'name'                  => $name,
            'txt_template'          => !empty($language) ? esc_html($txt_template)." (".$language.")" : esc_html($txt_template),
            'txt_depend_template'   => $data['txt_depend_template'],
            'value'                 => get_post_meta($post->ID, $name, true) ? get_post_meta($post->ID, $name, true) : '',
            'templates'             => productLayoutWPB()->get_list_template_by_language($table,$language),
            'desc'                  => $data['desc'],
            'desc_url'              => $data['desc_url'],
            'txt_all'               => $data['txt_all'],
        );
        productLayoutWPB()->get_file_template( 'metabox-special', array('options' => $options, 'type' => 'single') );
    }

    public function save_product_detail_fields($post_id,$post)
    {
        if ( empty( $post_id ) || empty( $post ) ) {
            return;
        }
        $language = productLayoutWPB()->current_language();
        if(!empty($language)){
            $name = 'mst_pclfvc_product_single_'.$language;
        }else{
            $name = 'mst_pclfvc_product_single';
        }
        if(isset($_POST[$name])){
            $template = $_POST[$name];
            update_post_meta( $post_id, $name, $template );
        }
    }

    public function add_edit_attribute_fields()
    {
        $attribute_id = isset( $_GET['edit'] ) ? absint( sanitize_text_field( $_GET['edit'] ) ) : 0;
        $language   = productLayoutWPB()->current_language();
        $table      = productLayoutWPB()->get_table_by_type_template('attribute');
        $templates  = productLayoutWPB()->get_list_template_by_language($table,$language);
        $flag       = productLayoutWPB()->check_have_template_active($templates);
        $name       = 'mst_template_attribute';
        if($attribute_id){
            $option_name    = !empty($language) ? $name.'_'.$attribute_id.'_'.$language : $name.'_'.$attribute_id;
            $selected       = get_option($option_name); 
        }else{
            $selected   = ''; 
        }

        $options        = array();
        $data           = productLayoutWPB()->get_attr_archive_info('attribute');
        $txt_template   = esc_html__('Template',MST_CPLFVC);
        $options[]      = array(
                'name'          => $name,
                'txt_template'  => !empty($language) ? esc_html($txt_template)." (".$language.")" : esc_html($txt_template),
                'value'         => $selected,
                'templates'     => $templates,
                'flag'          => $flag,
                'desc'          => $data['desc'],
                'desc_url'      => $data['desc_url'],
                'txt_all'       => $data['txt_all'],
        );
        productLayoutWPB()->get_file_template( 'metabox', array('options' => $options) );
    }

    public function save_attribute_fields($attribute_id)
    {
        if ( is_admin() && isset( $_POST['mst_template_attribute'] ) ) {
            $language   = productLayoutWPB()->current_language();
            $name = "mst_template_attribute_$attribute_id";
            $option   = !empty($language) ? $name.'_'.$language : $name;
            update_option( $option, sanitize_text_field( $_POST['mst_template_attribute'] ) );
        }
    }

    public function delete_attribute_fields($attribute_id)
    {
        $language   = productLayoutWPB()->current_language();
        $name = "mst_template_attribute_$attribute_id";
        $option   = !empty($language) ? $name.'_'.$language : $name;
        if( get_option($option) ){
            delete_option($option);
        }
    }
}